import 'dart:async';

import 'package:webroker/client.dart' as webroker;
import 'package:webroker/target.dart';

import 'addr.dart';
import 'node.dart';

class Listener {
  List<Addr> brokers;
  Node node;
  bool _close = false;

  Listener(this.brokers, this.node);

  close() {
    _close = true;
  }

  Future<void> _connect(Addr broker) async {
    var client = await webroker.Client.connect(broker.host, broker.port);
    try {
      node.peer.webroker = Target(client.host, client.port, client.id);
      await node.publish();
      while (!_close) {
        var msg = await client.next();
        await node.input(msg);
      }
    } finally {
      try {
        await client.close();
      } catch (_) {}
    }
  }

  Future<void> listen() async {
    for (int i = 0; _close != true; ++i) {
      var broker = brokers[i % brokers.length];
      try {
        await _connect(broker);
        await Future.delayed(Duration(milliseconds: 500));
      } catch (e) {
        print(e);
      }
    }
  }
}
